# 🌟 EdgeDeveloperPlatform - EDP Release 'PoC'

Telekom MMS & T-Systems, December 2024

> **Tagline:** Change the way we work with IDP's.

---

## 📋 Table of Contents

- [🌟 EdgeDeveloperPlatform - EDP Release 'PoC'](#-edgedeveloperplatform---edp-release-poc)
  - [📋 Table of Contents](#-table-of-contents)
  - [📖 About the Product](#-about-the-product)
    - [🛠️ Application Stack](#️-application-stack)
  - [📖 Access our Documentation](#-access-our-documentation)
  - [📝 License](#-license)

---

## 📖 About the Product

**edpbuilder** is a tool to quickly instantiate and manage **I**nternal **D**eveloper **P**latform's (**IDP**s).
The **E**dge **D**eveloper **P**latform Builder(**edp**builder) can easily setup a Kubenetes cluster (local kind cluster or OSC instance) and deploy tools to manage the Kubernetes resources and the software lifecicle of an application.
One usecase to demonstrate the capabilities of our tool is the PetClinic Application. (LINK)

### 🛠️ Application Stack

- **Version-Control:** Forgejo
- **CI:** Forgejo Actions
- **CD:** ArgoCD
- **Monitoring:** Grafana, Prometheus, Loki, Promtail
- **SSO:** Keycloak
- **Developer Portal:** Backstage
- **Secret-Management:** OpenBao, external-secrets
- **Infrastructur-Provisioning:** Crossplane

## 📖 Access our Documentation

Our documentation is designed to be easily accessible regardless of your environment. Here are three primary ways to view it:

1. **Backstage in Our OSC**  
   Our documentation can be easily accessed through a Backstage instance hosted on our Open Sovereign Cloud (OSC). Simply log in to our OSC Backstage platform to read through the documentation.

2. **Local Backstage in a Kind Cluster**  
    Using the edpbuilder, you can set up a local IDP that comes with a Backstage instance containing the documentation.
   *How to set up a local IDP on a kind cluster is explained here: XXXXX*

3. **Forgejo Repository**  
    If you prefer direct access, the content of our documentation is centrally defined and maintained within the docs folder of this repository.

---

## 📝 License

[LICENSE]
